Index: trunk/NEMOGCM/NEMO/OPA_SRC/TRA/zpshde.F90
===================================================================
--- trunk/NEMOGCM/NEMO/OPA_SRC/TRA/zpshde.F90	(revision 2527)
+++ trunk/NEMOGCM/NEMO/OPA_SRC/TRA/zpshde.F90	(revision 2528)
@@ -1,7 +1,12 @@
 MODULE zpshde
-   !!==============================================================================
+   !!======================================================================
    !!                       ***  MODULE zpshde   ***
-   !! z-coordinate - partial step : Horizontal Derivative
-   !!==============================================================================
+   !! z-coordinate + partial step : Horizontal Derivative at ocean bottom level
+   !!======================================================================
+   !! History :  OPA  !  2002-04  (A. Bozec)  Original code
+   !!   NEMO     1.0  !  2002-08  (G. Madec E. Durand)  Optimization and Free form
+   !!             -   !  2004-03  (C. Ethe)  adapted for passive tracers
+   !!            3.3  !  2010-05  (C. Ethe, G. Madec)  merge TRC-TRA 
+   !!======================================================================
    
    !!----------------------------------------------------------------------
@@ -9,10 +14,9 @@
    !!                   ocean level (Z-coord. with Partial Steps)
    !!----------------------------------------------------------------------
-   !! * Modules used
-   USE dom_oce         ! ocean space domain variables
-   USE oce             ! ocean dynamics and tracers variables
+   USE oce             ! ocean: dynamics and tracers variables
+   USE dom_oce         ! domain: ocean variables
    USE phycst          ! physical constants
+   USE eosbn2          ! ocean equation of state
    USE in_out_manager  ! I/O manager
-   USE eosbn2          ! ocean equation of state
    USE lbclnk          ! lateral boundary conditions (or mpp link)
 
@@ -20,10 +24,5 @@
    PRIVATE
 
-   !! * Routine accessibility
-   PUBLIC zps_hde          ! routine called by step.F90
-
-   !! * module variables
-   INTEGER, DIMENSION(jpi,jpj) ::   &
-      mbatu, mbatv      ! bottom ocean level index at U- and V-points
+   PUBLIC   zps_hde    ! routine called by step.F90
 
    !! * Substitutions
@@ -31,18 +30,16 @@
 #  include "vectopt_loop_substitute.h90"
    !!----------------------------------------------------------------------
-   !!----------------------------------------------------------------------
-   !!  OPA 9.0 , LOCEAN-IPSL (2005) 
-   !! $Id$ 
-   !! This software is governed by the CeCILL licence see modipsl/doc/NEMO_CeCILL.txt 
+   !! NEMO/OPA 3.3 , NEMO Consortium (2010)
+   !! $Id$
+   !! Software governed by the CeCILL licence     (NEMOGCM/NEMO_CeCILL.txt)
    !!----------------------------------------------------------------------
 CONTAINS
 
-   SUBROUTINE zps_hde ( kt, ptem, psal, prd ,   &
-                            pgtu, pgsu, pgru,   &
-                            pgtv, pgsv, pgrv  )
+   SUBROUTINE zps_hde( kt, kjpt, pta, pgtu, pgtv,   &
+                                 prd, pgru, pgrv    )
       !!----------------------------------------------------------------------
       !!                     ***  ROUTINE zps_hde  ***
       !!                    
-      !! ** Purpose :   Compute the horizontal derivative of T, S and rd
+      !! ** Purpose :   Compute the horizontal derivative of T, S and rho
       !!      at u- and v-points with a linear interpolation for z-coordinate
       !!      with partial steps.
@@ -78,162 +75,129 @@
       !!      formulation of the equation of state (eos).
       !!      Gradient formulation for rho :
-      !!          di(rho) = rd~ - rd(i,j,k) or rd (i+1,j,k) - rd~
-      !!
-      !! ** Action  : - pgtu, pgsu, pgru: horizontal gradient of T, S
-      !!                and rd at U-points 
-      !!              - pgtv, pgsv, pgrv: horizontal gradient of T, S
-      !!                and rd at V-points 
-      !!
-      !! History :
-      !!   8.5  !  02-04  (A. Bozec)  Original code
-      !!   8.5  !  02-08  (G. Madec E. Durand)  Optimization and Free form
+      !!          di(rho) = rd~ - rd(i,j,k) or rd(i+1,j,k) - rd~
+      !!
+      !! ** Action  : - pgtu, pgtv: horizontal gradient of tracer at u- & v-points
+      !!              - pgru, pgrv: horizontal gradient of rho (if present) at u- & v-points 
       !!----------------------------------------------------------------------
-      !! * Arguments
-      INTEGER, INTENT( in ) ::   kt ! ocean time-step index
-      REAL(wp), DIMENSION(jpi,jpj,jpk), INTENT( in ) ::   &
-         ptem, psal, prd            ! 3D T, S and rd fields
-      REAL(wp), DIMENSION(jpi,jpj), INTENT( out ) ::   &
-         pgtu, pgsu, pgru,       &  ! horizontal grad. of T, S and rd at u- 
-         pgtv, pgsv, pgrv           ! and v-points of the partial step level
-
-      !! * Local declarations
-      INTEGER ::   ji, jj,       &  ! Dummy loop indices
-                   iku,ikv          ! partial step level at u- and v-points
-      REAL(wp), DIMENSION(jpi,jpj) ::   &
-         zti, ztj, zsi, zsj,     &  ! interpolated value of T, S 
-         zri, zrj,               &  ! and rd
-         zhgi, zhgj                 ! depth of interpolation for eos2d
-      REAL(wp) ::   &
-         ze3wu, ze3wv,           &  ! temporary scalars
-         zmaxu1, zmaxu2,         &  !    "         "
-         zmaxv1, zmaxv2             !    "         "
-
-      ! Initialization (first time-step only): compute mbatu and mbatv
-      IF( kt == nit000 ) THEN
-         mbatu(:,:) = 0
-         mbatv(:,:) = 0
-         DO jj = 1, jpjm1
-            DO ji = 1, fs_jpim1   ! vector opt.
-               mbatu(ji,jj) = MAX( MIN( mbathy(ji,jj), mbathy(ji+1,jj  ) ) - 1, 2 )
-               mbatv(ji,jj) = MAX( MIN( mbathy(ji,jj), mbathy(ji  ,jj+1) ) - 1, 2 )
-            END DO
-         END DO
-         zti(:,:) = FLOAT( mbatu(:,:) )
-         ztj(:,:) = FLOAT( mbatv(:,:) )
-         ! lateral boundary conditions: T-point, sign unchanged
-         CALL lbc_lnk( zti , 'U', 1. )
-         CALL lbc_lnk( ztj , 'V', 1. )
-         mbatu(:,:) = MAX( INT( zti(:,:) ), 2 )
-         mbatv(:,:) = MAX( INT( ztj(:,:) ), 2 )
-      ENDIF
-      
-
-      ! Interpolation of T and S at the last ocean level
+      INTEGER                              , INTENT(in   )           ::  kt          ! ocean time-step index
+      INTEGER                              , INTENT(in   )           ::  kjpt        ! number of tracers
+      REAL(wp), DIMENSION(jpi,jpj,jpk,kjpt), INTENT(in   )           ::  pta         ! 4D tracers fields
+      REAL(wp), DIMENSION(jpi,jpj,    kjpt), INTENT(  out)           ::  pgtu, pgtv  ! hor. grad. of ptra at u- & v-pts 
+      REAL(wp), DIMENSION(jpi,jpj,jpk     ), INTENT(in   ), OPTIONAL ::  prd         ! 3D density anomaly fields
+      REAL(wp), DIMENSION(jpi,jpj         ), INTENT(  out), OPTIONAL ::  pgru, pgrv  ! hor. grad. of prd at u- & v-pts 
+      !!
+      INTEGER  ::   ji, jj, jn      ! Dummy loop indices
+      INTEGER  ::   iku, ikv, ikum1, ikvm1   ! partial step level (ocean bottom level) at u- and v-points
+      REAL(wp), DIMENSION(jpi,jpj,kjpt) ::   zti, ztj     ! interpolated value of tracer
+      REAL(wp), DIMENSION(jpi,jpj)      ::   zri, zrj     ! interpolated value of rd
+      REAL(wp), DIMENSION(jpi,jpj)      ::   zhi, zhj     ! depth of interpolation for eos2d
+      REAL(wp) ::  ze3wu, ze3wv, zmaxu, zmaxv  ! temporary scalars
+      !!----------------------------------------------------------------------
+
+      DO jn = 1, kjpt      !==   Interpolation of tracers at the last ocean level   ==!
+         !
 # if defined key_vectopt_loop
          jj = 1
          DO ji = 1, jpij-jpi   ! vector opt. (forced unrolled)
 # else
-      DO jj = 1, jpjm1
-         DO ji = 1, jpim1
-# endif
-            ! last level
-            iku = mbatu(ji,jj)
-            ikv = mbatv(ji,jj)
-
-            ze3wu  = fse3w(ji+1,jj  ,iku) - fse3w(ji,jj,iku)
-            ze3wv  = fse3w(ji  ,jj+1,ikv) - fse3w(ji,jj,ikv)
-            zmaxu1 =  ze3wu / fse3w(ji+1,jj  ,iku)
-            zmaxu2 = -ze3wu / fse3w(ji  ,jj  ,iku)
-            zmaxv1 =  ze3wv / fse3w(ji  ,jj+1,ikv)
-            zmaxv2 = -ze3wv / fse3w(ji  ,jj  ,ikv)
-
-            ! i- direction
-
-            IF( ze3wu >= 0. ) THEN      ! case 1
-               ! interpolated values of T and S
-               zti(ji,jj) = ptem(ji+1,jj,iku) + zmaxu1 * ( ptem(ji+1,jj,iku-1) - ptem(ji+1,jj,iku) )
-               zsi(ji,jj) = psal(ji+1,jj,iku) + zmaxu1 * ( psal(ji+1,jj,iku-1) - psal(ji+1,jj,iku) )
-               ! depth of the partial step level
-               zhgi(ji,jj) = fsdept(ji,jj,iku)
-               ! gradient of T and S
-               pgtu(ji,jj) = umask(ji,jj,1) * ( zti(ji,jj) - ptem(ji,jj,iku) )
-               pgsu(ji,jj) = umask(ji,jj,1) * ( zsi(ji,jj) - psal(ji,jj,iku) )
-
-            ELSE                        ! case 2
-               ! interpolated values of T and S
-               zti(ji,jj) = ptem(ji,jj,iku) + zmaxu2 * ( ptem(ji,jj,iku-1) - ptem(ji,jj,iku) )
-               zsi(ji,jj) = psal(ji,jj,iku) + zmaxu2 * ( psal(ji,jj,iku-1) - psal(ji,jj,iku) )
-               ! depth of the partial step level
-               zhgi(ji,jj) = fsdept(ji+1,jj,iku)
-               ! gradient of T and S 
-               pgtu(ji,jj) = umask(ji,jj,1) * ( ptem(ji+1,jj,iku) - zti (ji,jj) )
-               pgsu(ji,jj) = umask(ji,jj,1) * ( psal(ji+1,jj,iku) - zsi (ji,jj) )
-            ENDIF
-
-            ! j- direction
-
-            IF( ze3wv >= 0. ) THEN      ! case 1
-               ! interpolated values of T and S
-               ztj(ji,jj) = ptem(ji,jj+1,ikv) + zmaxv1 * ( ptem(ji,jj+1,ikv-1) - ptem(ji,jj+1,ikv) )
-               zsj(ji,jj) = psal(ji,jj+1,ikv) + zmaxv1 * ( psal(ji,jj+1,ikv-1) - psal(ji,jj+1,ikv) )
-               ! depth of the partial step level
-               zhgj(ji,jj) = fsdept(ji,jj,ikv) 
-               ! gradient of T and S
-               pgtv(ji,jj) = vmask(ji,jj,1) * ( ztj(ji,jj) - ptem(ji,jj,ikv) )
-               pgsv(ji,jj) = vmask(ji,jj,1) * ( zsj(ji,jj) - psal(ji,jj,ikv) )
-
-            ELSE                        ! case 2
-               ! interpolated values of T and S
-               ztj(ji,jj) = ptem(ji,jj,ikv) + zmaxv2 * ( ptem(ji,jj,ikv-1) - ptem(ji,jj,ikv) )
-               zsj(ji,jj) = psal(ji,jj,ikv) + zmaxv2 * ( psal(ji,jj,ikv-1) - psal(ji,jj,ikv) ) 
-               ! depth of the partial step level
-               zhgj(ji,jj) = fsdept(ji,jj+1,ikv) 
-               ! gradient of T and S
-               pgtv(ji,jj) = vmask(ji,jj,1) * ( ptem(ji,jj+1,ikv) - ztj(ji,jj) )
-               pgsv(ji,jj) = vmask(ji,jj,1) * ( psal(ji,jj+1,ikv) - zsj(ji,jj) )
-            ENDIF
+         DO jj = 1, jpjm1
+            DO ji = 1, jpim1
+# endif
+               iku = mbku(ji,jj)   ;   ikum1 = MAX( iku , 1 )        ! last and before last ocean level at u- & v-points
+               ikv = mbkv(ji,jj)   ;   ikvm1 = MAX( ikv , 1 )        ! if level first is a p-step, ik.m1=1
+               ze3wu = fse3w(ji+1,jj  ,iku) - fse3w(ji,jj,iku)
+               ze3wv = fse3w(ji  ,jj+1,ikv) - fse3w(ji,jj,ikv)
+               !
+               ! i- direction
+               IF( ze3wu >= 0._wp ) THEN      ! case 1
+                  zmaxu =  ze3wu / fse3w(ji+1,jj,iku)
+                  ! interpolated values of tracers
+                  zti(ji,jj,jn) = pta(ji+1,jj,iku,jn) + zmaxu * ( pta(ji+1,jj,ikum1,jn) - pta(ji+1,jj,iku,jn) )
+                  ! gradient of  tracers
+                  pgtu(ji,jj,jn) = umask(ji,jj,1) * ( zti(ji,jj,jn) - pta(ji,jj,iku,jn) )
+               ELSE                           ! case 2
+                  zmaxu = -ze3wu / fse3w(ji,jj,iku)
+                  ! interpolated values of tracers
+                  zti(ji,jj,jn) = pta(ji,jj,iku,jn) + zmaxu * ( pta(ji,jj,ikum1,jn) - pta(ji,jj,iku,jn) )
+                  ! gradient of tracers
+                  pgtu(ji,jj,jn) = umask(ji,jj,1) * ( pta(ji+1,jj,iku,jn) - zti(ji,jj,jn) )
+               ENDIF
+               !
+               ! j- direction
+               IF( ze3wv >= 0._wp ) THEN      ! case 1
+                  zmaxv =  ze3wv / fse3w(ji,jj+1,ikv)
+                  ! interpolated values of tracers
+                  ztj(ji,jj,jn) = pta(ji,jj+1,ikv,jn) + zmaxv * ( pta(ji,jj+1,ikvm1,jn) - pta(ji,jj+1,ikv,jn) )
+                  ! gradient of tracers
+                  pgtv(ji,jj,jn) = vmask(ji,jj,1) * ( ztj(ji,jj,jn) - pta(ji,jj,ikv,jn) )
+               ELSE                           ! case 2
+                  zmaxv =  -ze3wv / fse3w(ji,jj,ikv)
+                  ! interpolated values of tracers
+                  ztj(ji,jj,jn) = pta(ji,jj,ikv,jn) + zmaxv * ( pta(ji,jj,ikvm1,jn) - pta(ji,jj,ikv,jn) )
+                  ! gradient of tracers
+                  pgtv(ji,jj,jn) = vmask(ji,jj,1) * ( pta(ji,jj+1,ikv,jn) - ztj(ji,jj,jn) )
+               ENDIF
 # if ! defined key_vectopt_loop
+            END DO
+# endif
          END DO
-# endif
+         CALL lbc_lnk( pgtu(:,:,jn), 'U', -1. )   ;   CALL lbc_lnk( pgtv(:,:,jn), 'V', -1. )   ! Lateral boundary cond.
+         !
       END DO
 
-      ! Compute interpolated rd from zti, zsi, ztj, zsj for the 2 cases at the depth of the partial
-      ! step and store it in  zri, zrj for each  case
-      CALL eos( zti, zsi, zhgi, zri )
-      CALL eos( ztj, zsj, zhgj, zrj )
-
-
-      ! Gradient of density at the last level 
+      ! horizontal derivative of density anomalies (rd)
+      IF( PRESENT( prd ) ) THEN         ! depth of the partial step level
 # if defined key_vectopt_loop
          jj = 1
          DO ji = 1, jpij-jpi   ! vector opt. (forced unrolled)
 # else
-      DO jj = 1, jpjm1
-         DO ji = 1, jpim1
-# endif
-            iku = mbatu(ji,jj)
-            ikv = mbatv(ji,jj)
-            ze3wu  = fse3w(ji+1,jj  ,iku) - fse3w(ji,jj,iku)
-            ze3wv  = fse3w(ji  ,jj+1,ikv) - fse3w(ji,jj,ikv)
-            IF( ze3wu >= 0. ) THEN    ! i-direction: case 1
-               pgru(ji,jj) = umask(ji,jj,1) * ( zri(ji,jj) - prd(ji,jj,iku) )
-            ELSE                      ! i-direction: case 2
-               pgru(ji,jj) = umask(ji,jj,1) * ( prd(ji+1,jj,iku) - zri(ji,jj) )
-            ENDIF
-            IF( ze3wv >= 0. ) THEN    ! j-direction: case 1
-               pgrv(ji,jj) = vmask(ji,jj,1) * ( zrj(ji,jj) - prd(ji,jj,ikv) )  
-            ELSE                      ! j-direction: case 2
-               pgrv(ji,jj) = vmask(ji,jj,1) * ( prd(ji,jj+1,ikv) - zrj(ji,jj) )
-            ENDIF
+         DO jj = 1, jpjm1
+            DO ji = 1, jpim1
+# endif
+               iku = mbku(ji,jj)
+               ikv = mbkv(ji,jj)
+               ze3wu  = fse3w(ji+1,jj  ,iku) - fse3w(ji,jj,iku)
+               ze3wv  = fse3w(ji  ,jj+1,ikv) - fse3w(ji,jj,ikv)
+               IF( ze3wu >= 0._wp ) THEN   ;   zhi(ji,jj) = fsdept(ji  ,jj,iku)     ! i-direction: case 1
+               ELSE                        ;   zhi(ji,jj) = fsdept(ji+1,jj,iku)     ! -     -      case 2
+               ENDIF
+               IF( ze3wv >= 0._wp ) THEN   ;   zhj(ji,jj) = fsdept(ji,jj  ,ikv)     ! j-direction: case 1
+               ELSE                        ;   zhj(ji,jj) = fsdept(ji,jj+1,ikv)     ! -     -      case 2
+               ENDIF
 # if ! defined key_vectopt_loop
+            END DO
+# endif
          END DO
-# endif
-      END DO
-
-      ! Lateral boundary conditions on each gradient
-      CALL lbc_lnk( pgtu , 'U', -1. )   ;   CALL lbc_lnk( pgtv , 'V', -1. )
-      CALL lbc_lnk( pgsu , 'U', -1. )   ;   CALL lbc_lnk( pgsv , 'V', -1. )
-      CALL lbc_lnk( pgru , 'U', -1. )   ;   CALL lbc_lnk( pgrv , 'V', -1. )
-
+
+         ! Compute interpolated rd from zti, ztj for the 2 cases at the depth of the partial
+         ! step and store it in  zri, zrj for each  case
+         CALL eos( zti, zhi, zri )   ;   CALL eos( ztj, zhj, zrj )
+
+         ! Gradient of density at the last level 
+# if defined key_vectopt_loop
+         jj = 1
+         DO ji = 1, jpij-jpi   ! vector opt. (forced unrolled)
+# else
+         DO jj = 1, jpjm1
+            DO ji = 1, jpim1
+# endif
+               iku = mbku(ji,jj)
+               ikv = mbkv(ji,jj)
+               ze3wu  = fse3w(ji+1,jj  ,iku) - fse3w(ji,jj,iku)
+               ze3wv  = fse3w(ji  ,jj+1,ikv) - fse3w(ji,jj,ikv)
+               IF( ze3wu >= 0._wp ) THEN   ;   pgru(ji,jj) = umask(ji,jj,1) * ( zri(ji  ,jj) - prd(ji,jj,iku) )   ! i: 1
+               ELSE                        ;   pgru(ji,jj) = umask(ji,jj,1) * ( prd(ji+1,jj,iku) - zri(ji,jj) )   ! i: 2
+               ENDIF
+               IF( ze3wv >= 0._wp ) THEN   ;   pgrv(ji,jj) = vmask(ji,jj,1) * ( zrj(ji,jj  ) - prd(ji,jj,ikv) )   ! j: 1
+               ELSE                        ;   pgrv(ji,jj) = vmask(ji,jj,1) * ( prd(ji,jj+1,ikv) - zrj(ji,jj) )   ! j: 2
+               ENDIF
+# if ! defined key_vectopt_loop
+            END DO
+# endif
+         END DO
+         CALL lbc_lnk( pgru , 'U', -1. )   ;   CALL lbc_lnk( pgrv , 'V', -1. )   ! Lateral boundary conditions
+         !
+      END IF
+      !
    END SUBROUTINE zps_hde
 
Index: trunk/NEMOGCM/NEMO/OPA_SRC/TRD/trdicp.F90
===================================================================
--- trunk/NEMOGCM/NEMO/OPA_SRC/TRD/trdicp.F90	(revision 2527)
+++ trunk/NEMOGCM/NEMO/OPA_SRC/TRD/trdicp.F90	(revision 2528)
@@ -4,9 +4,5 @@
    !! Ocean diagnostics:  ocean tracers and dynamic trends
    !!=====================================================================
-   !! History :       !  91-12 (G. Madec)
-   !!                 !  92-06 (M. Imbard) add time step frequency
-   !!                 !  96-01 (G. Madec)  terrain following coordinates
-   !!            8.5  !  02-06 (G. Madec)  F90: Free form and module
-   !!            9.0  !  04-08 (C. Talandier) New trends organization
+   !! History :  1.0  !  2004-08 (C. Talandier) New trends organization
    !!----------------------------------------------------------------------
 #if  defined key_trdtra   ||   defined key_trddyn   ||   defined key_esopa
@@ -14,5 +10,4 @@
    !!   'key_trdtra'  or                  active tracers trends diagnostics
    !!   'key_trddyn'                            momentum trends diagnostics
-   !!----------------------------------------------------------------------
    !!----------------------------------------------------------------------
    !!   trd_icp          : compute the basin averaged properties for tra/dyn 
@@ -48,12 +43,12 @@
 #  include "vectopt_loop_substitute.h90"
    !!----------------------------------------------------------------------
-   !!   OPA 9.0 , LOCEAN-IPSL (2005) 
-   !! $Id$ 
-   !! Software governed by the CeCILL licence (modipsl/doc/NEMO_CeCILL.txt)
+   !! NEMO/OPA 3.3 , NEMO Consortium (2010)
+   !! $Id$
+   !! Software governed by the CeCILL licence (NEMOGCM/NEMO_CeCILL.txt)
    !!----------------------------------------------------------------------
 
 CONTAINS
 
-   SUBROUTINE trd_2d( ptrd2dx, ptrd2dy, ktrd , ctype, clpas )
+   SUBROUTINE trd_2d( ptrd2dx, ptrd2dy, ktrd , ctype )
       !!---------------------------------------------------------------------
       !!                  ***  ROUTINE trd_2d  ***
@@ -66,15 +61,10 @@
       INTEGER                     , INTENT(in   ) ::   ktrd                ! tracer trend index
       CHARACTER(len=3)            , INTENT(in   ) ::   ctype               ! momentum ('DYN') or tracers ('TRA') trends
-      CHARACTER(len=3)            , INTENT(in   ), OPTIONAL ::   clpas     ! number of passage
       !!
       INTEGER  ::   ji, jj                                                 ! loop indices
-      CHARACTER(len=3) ::   cpas                                           ! number of passage
       REAL(wp) ::   zmsku, zbtu, zbt                                       ! temporary scalars
       REAL(wp) ::   zmskv, zbtv                                            !    "         "
       !!----------------------------------------------------------------------
 
-      ! Control of optional arguments
-      cpas = 'fst'
-      IF( PRESENT(clpas) )  cpas = clpas
 
       ! 1. Mask trends
@@ -123,8 +113,6 @@
          !
       CASE( 'TRA' )              ! Tracers
-         IF( cpas == 'fst' )   THEN
-            tmo(ktrd) = 0.e0
-            smo(ktrd) = 0.e0
-         ENDIF
+         tmo(ktrd) = 0.e0
+         smo(ktrd) = 0.e0
          DO jj = 1, jpj
             DO ji = 1, jpi
@@ -156,8 +144,6 @@
          !
       CASE( 'TRA' )              ! Tracers
-         IF( cpas == 'fst' )   THEN
-            t2(ktrd) = 0.e0
-            s2(ktrd) = 0.e0
-         ENDIF
+         t2(ktrd) = 0.e0
+         s2(ktrd) = 0.e0
          DO jj = 1, jpj
             DO ji = 1, jpi
@@ -173,5 +159,5 @@
 
 
-   SUBROUTINE trd_3d( ptrd3dx, ptrd3dy, ktrd, ctype, clpas )
+   SUBROUTINE trd_3d( ptrd3dx, ptrd3dy, ktrd, ctype )
       !!---------------------------------------------------------------------
       !!                  ***  ROUTINE trd_3d  ***
@@ -184,14 +170,8 @@
       INTEGER,                          INTENT(in   ) ::   ktrd               ! momentum or tracer trend index
       CHARACTER(len=3),                 INTENT(in   ) ::   ctype              ! momentum ('DYN') or tracers ('TRA') trends
-      CHARACTER(len=3),                 INTENT(in   ), OPTIONAL ::   clpas    ! number of passage
       !!
       INTEGER ::   ji, jj, jk
-      CHARACTER(len=3) ::   cpas                                              ! number of passage
       REAL(wp) ::   zbt, zbtu, zbtv, zmsku, zmskv                             ! temporary scalars
       !!----------------------------------------------------------------------
-
-      ! Control of optional arguments
-      cpas = 'fst'
-      IF( PRESENT(clpas) )  cpas = clpas
 
       ! 1. Mask the trends
@@ -242,8 +222,6 @@
          !
       CASE( 'TRA' )              ! Tracers
-         IF( cpas == 'fst' )   THEN
-            tmo(ktrd) = 0.e0
-            smo(ktrd) = 0.e0
-         ENDIF
+         tmo(ktrd) = 0.e0
+         smo(ktrd) = 0.e0
          DO jk = 1, jpkm1
             DO jj = 1, jpj
@@ -279,8 +257,6 @@
          !
       CASE( 'TRA' )              ! Tracers
-         IF( cpas == 'fst' )   THEN
-            t2(ktrd) = 0.e0
-            s2(ktrd) = 0.e0
-         ENDIF
+         t2(ktrd) = 0.e0
+         s2(ktrd) = 0.e0
          DO jk = 1, jpk
             DO jj = 1, jpj
@@ -389,5 +365,5 @@
          zkepe(:,:,:) = 0.e0
    
-         CALL eos( tn, sn, rhd, rhop )       ! now potential and in situ densities
+         CALL eos( tsn, rhd, rhop )       ! now potential and in situ densities
 
          ! Density flux at w-point
@@ -600,5 +576,6 @@
             WRITE (numout,*)
             WRITE (numout,9400) kt
-            WRITE (numout,9401) (tmo(jpicpt_xad)+tmo(jpicpt_yad))/ tvolt, (smo(jpicpt_xad)+smo(jpicpt_yad))/ tvolt
+            WRITE (numout,9401)  tmo(jpicpt_xad) / tvolt, smo(jpicpt_xad) / tvolt
+            WRITE (numout,9411)  tmo(jpicpt_yad) / tvolt, smo(jpicpt_yad) / tvolt
             WRITE (numout,9402)  tmo(jpicpt_zad) / tvolt, smo(jpicpt_zad) / tvolt
             WRITE (numout,9403)  tmo(jpicpt_ldf) / tvolt, smo(jpicpt_ldf) / tvolt
@@ -617,5 +594,6 @@
 9400     FORMAT(' tracer trend at it= ',i6,' :     temperature',   &
               '              salinity',/' ============================')
-9401     FORMAT(' horizontal advection        ',e20.13,'     ',e20.13)
+9401     FORMAT(' zonal      advection        ',e20.13,'     ',e20.13)
+9411     FORMAT(' meridional advection        ',e20.13,'     ',e20.13)
 9402     FORMAT(' vertical advection          ',e20.13,'     ',e20.13)
 9403     FORMAT(' horizontal diffusion        ',e20.13,'     ',e20.13)
@@ -633,5 +611,6 @@
             WRITE (numout,*)
             WRITE (numout,9420) kt
-            WRITE (numout,9421) ( t2(jpicpt_xad)+t2(jpicpt_yad) )/ tvolt, ( s2(jpicpt_xad)+s2(jpicpt_yad) )/ tvolt
+            WRITE (numout,9421)   t2(jpicpt_xad) / tvolt, s2(jpicpt_xad) / tvolt
+            WRITE (numout,9431)   t2(jpicpt_yad) / tvolt, s2(jpicpt_yad) / tvolt
             WRITE (numout,9422)   t2(jpicpt_zad) / tvolt, s2(jpicpt_zad) / tvolt
             WRITE (numout,9423)   t2(jpicpt_ldf) / tvolt, s2(jpicpt_ldf) / tvolt
@@ -650,5 +629,6 @@
 9420     FORMAT(' tracer**2 trend at it= ', i6, ' :      temperature',   &
             '               salinity', /, ' ===============================')
-9421     FORMAT(' horizontal advection      * t   ', e20.13, '     ', e20.13)
+9421     FORMAT(' zonal      advection      * t   ', e20.13, '     ', e20.13)
+9431     FORMAT(' meridional advection      * t   ', e20.13, '     ', e20.13)
 9422     FORMAT(' vertical advection        * t   ', e20.13, '     ', e20.13)
 9423     FORMAT(' horizontal diffusion      * t   ', e20.13, '     ', e20.13)
@@ -705,19 +685,17 @@
 
 CONTAINS
-   SUBROUTINE trd_2d( ptrd2dx, ptrd2dy, ktrd , ctype, clpas )       ! Empty routine
+   SUBROUTINE trd_2d( ptrd2dx, ptrd2dy, ktrd , ctype )       ! Empty routine
       REAL, DIMENSION(:,:) ::   ptrd2dx, ptrd2dy
       INTEGER                     , INTENT(in   ) ::   ktrd         ! tracer trend index
       CHARACTER(len=3)            , INTENT(in   ) ::   ctype        ! momentum ('DYN') or tracers ('TRA') trends
-      CHARACTER(len=3), INTENT(in), OPTIONAL ::   clpas             ! number of passage
       WRITE(*,*) 'trd_2d: You should not have seen this print! error ?', &
-          &       ptrd2dx(1,1), ptrd2dy(1,1), ktrd, ctype, clpas
+          &       ptrd2dx(1,1), ptrd2dy(1,1), ktrd, ctype
    END SUBROUTINE trd_2d
-   SUBROUTINE trd_3d( ptrd3dx, ptrd3dy, ktrd , ctype, clpas )       ! Empty routine
+   SUBROUTINE trd_3d( ptrd3dx, ptrd3dy, ktrd , ctype )       ! Empty routine
       REAL, DIMENSION(:,:,:) ::   ptrd3dx, ptrd3dy
       INTEGER                     , INTENT(in   ) ::   ktrd         ! tracer trend index
       CHARACTER(len=3)            , INTENT(in   ) ::   ctype        ! momentum ('DYN') or tracers ('TRA') trends
-      CHARACTER(len=3), INTENT(in), OPTIONAL ::   clpas             ! number of passage
       WRITE(*,*) 'trd_3d: You should not have seen this print! error ?', &
-          &       ptrd3dx(1,1,1), ptrd3dy(1,1,1), ktrd, ctype, clpas
+          &       ptrd3dx(1,1,1), ptrd3dy(1,1,1), ktrd, ctype
    END SUBROUTINE trd_3d
    SUBROUTINE trd_icp_init               ! Empty routine
Index: trunk/NEMOGCM/NEMO/OPA_SRC/TRD/trdicp_oce.F90
===================================================================
--- trunk/NEMOGCM/NEMO/OPA_SRC/TRD/trdicp_oce.F90	(revision 2527)
+++ trunk/NEMOGCM/NEMO/OPA_SRC/TRD/trdicp_oce.F90	(revision 2528)
@@ -84,7 +84,7 @@
 #endif
    !!----------------------------------------------------------------------
-   !! NEMO/OPA 3.2 , LOCEAN-IPSL (2009) 
+   !! NEMO/OPA 3.3 , NEMO Consortium (2010)
    !! $Id$ 
-   !! Software governed by the CeCILL licence (modipsl/doc/NEMO_CeCILL.txt)
+   !! Software governed by the CeCILL licence (NEMOGCM/NEMO_CeCILL.txt)
    !!======================================================================
 END MODULE trdicp_oce
Index: trunk/NEMOGCM/NEMO/OPA_SRC/TRD/trdmld.F90
===================================================================
--- trunk/NEMOGCM/NEMO/OPA_SRC/TRD/trdmld.F90	(revision 2527)
+++ trunk/NEMOGCM/NEMO/OPA_SRC/TRD/trdmld.F90	(revision 2528)
@@ -56,7 +56,7 @@
 #  include "zdfddm_substitute.h90"
    !!----------------------------------------------------------------------
-   !!   OPA 9.0 , LOCEAN-IPSL (2005) 
+   !! NEMO/OPA 3.3 , NEMO Consortium (2010)
    !! $Id$ 
-   !! This software is governed by the CeCILL licence see modipsl/doc/NEMO_CeCILL.txt 
+   !! Software governed by the CeCILL licence (NEMOGCM/NEMO_CeCILL.txt)
    !!----------------------------------------------------------------------
 
@@ -757,5 +757,5 @@
       END IF
 
-      IF( ( lk_trdmld ) .AND. ( n_cla == 1 ) ) THEN
+      IF( ( lk_trdmld ) .AND. ( nn_cla == 1 ) ) THEN
          WRITE(numout,cform_war)
          WRITE(numout,*) '                You set n_cla = 1. Note that the Mixed-Layer diagnostics  '
@@ -873,5 +873,5 @@
       IF(lwp) WRITE(numout,*) ' Name of NETCDF file ', clhstnam
       CALL histbeg( clhstnam, jpi, glamt, jpj, gphit,                                            &
-      &             1, jpi, 1, jpj, nit000-1, zjulian, rdt, nh_t, nidtrd, domain_id=nidom )
+      &             1, jpi, 1, jpj, nit000-1, zjulian, rdt, nh_t, nidtrd, domain_id=nidom, snc4chunks=snc4set )
 
       !-- Define the ML depth variable
@@ -925,5 +925,5 @@
 
       !-- Leave IOIPSL/NetCDF define mode
-      CALL histend( nidtrd )
+      CALL histend( nidtrd, snc4set )
 
 #endif        /* key_dimgout */
Index: trunk/NEMOGCM/NEMO/OPA_SRC/TRD/trdmld_oce.F90
===================================================================
--- trunk/NEMOGCM/NEMO/OPA_SRC/TRD/trdmld_oce.F90	(revision 2527)
+++ trunk/NEMOGCM/NEMO/OPA_SRC/TRD/trdmld_oce.F90	(revision 2528)
@@ -83,7 +83,7 @@
 #endif
    !!----------------------------------------------------------------------
-   !!  OPA 9.0 , LOCEAN-IPSL (2005) 
+   !! NEMO/OPA 3.3 , NEMO Consortium (2010)
    !! $Id$ 
-   !! Software governed by the CeCILL licence (modipsl/doc/NEMO_CeCILL.txt)
+   !! Software governed by the CeCILL licence (NEMOGCM/NEMO_CeCILL.txt)
    !!======================================================================
 END MODULE trdmld_oce
Index: trunk/NEMOGCM/NEMO/OPA_SRC/TRD/trdmld_rst.F90
===================================================================
--- trunk/NEMOGCM/NEMO/OPA_SRC/TRD/trdmld_rst.F90	(revision 2527)
+++ trunk/NEMOGCM/NEMO/OPA_SRC/TRD/trdmld_rst.F90	(revision 2528)
@@ -23,7 +23,7 @@
 
    !!---------------------------------------------------------------------------------
-   !! OPA 9.0 , LOCEAN-IPSL (2006) 
+   !! NEMO/OPA 3.3 , NEMO Consortium (2010)
    !! $Id$ 
-   !! Software governed by the CeCILL licence (modipsl/doc/NEMO_CeCILL.txt)
+   !! Software governed by the CeCILL licence (NEMOGCM/NEMO_CeCILL.txt)
    !!---------------------------------------------------------------------------------
   
